Exit status


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Exit status
# 1  
Old 09-08-2008
Exit status

I'm preparing for exam and one of exams is to write own test command...

I wonder if in unix is a command which just returns exit code you specify..

I know I can easily write a function like this:

Code:
exStatus() {

  return $1

}

-> my question is rather theoretical

thank you!
# 2  
Old 09-08-2008
Quote:
Originally Posted by MartyIX
I'm preparing for exam and one of exams is to write own test command...

Are you expected to do it as a shell script? If so, why? It seems like a pointless task even as a learning experience.

Code:
testing()
{
 test "$@"
 echo $?
}

# 3  
Old 09-08-2008
@cfajohnson: Of course without using test command ;-)

Well, pointless maybe but it's not so easy to do :-) I've already done a half but it took me three hours ;-)
# 4  
Old 09-08-2008

What do you have so far? What else do you need?

Does it have to be a complete replacement for test?
# 5  
Old 09-08-2008
I've got operations: -gt -lt == ( ) -z -n
I'm working on it and I'll post it here tomorrow (It's midnight here) I hope I'll finish the most important things

Well, it doesn't have to be a complete replacement but the more the bette :-) It's a good for exercise...
# 6  
Old 09-08-2008
Quote:
Originally Posted by MartyIX
I've got operations: -gt -lt == ( ) -z -n

The standard test doesn't have a '==' operator.
Quote:
I'm working on it and I'll post it here tomorrow (It's midnight here) I hope I'll finish the most important things

I look forward to seeing it.
Quote:
Well, it doesn't have to be a complete replacement but the more the bette :-) It's a good for exercise...

Do you have to do it without external commands?
# 7  
Old 09-08-2008
> Do you have to do it without external commands?

I'm not sure what you exactly mean. I may use whatever command except test - I got the assignment this way.

> I look forward to seeing it.
I don't think you'll be pleased with great source code :-)

>The standard test doesn't have a '==' operator.
You're right it has just '=' operator.

examples:
./test.sh 1 = 2 -a -z " " -o -n " " 2>/dev/null # I'm sending debugging info to stderr
./test.sh '(' 1 -lt 2 ')' -a '(' -z " " -o -n " " ')' 2>/dev/null

Code:
#!/bin/sh   


  # File: test.sh
  
  verbose=2; # TODO

  # for debugging purposes; TODO - delete after finishing
  if [ "$1" == "-x" ]; then
    set -x;
    shift 1
  fi
  
  expr2() { # expr without output
   
    result=$( expr "$@" )
    return $( expr $result "=" 0 )  
  }
  
  usage() {
  
    echo "Usage: "; # TODO   
  }


  process() {
    
    num_stack=0;
    op_stack=0;
    number1=0;
    number2=0;
    op="";    
    opened_with_logical_switch=$1;
    deepness=$2    
    shift 2;
    
    num_stack_in() {  # number stack
      
      num_stack=$(( $num_stack + 1 ));

      echo "Deepness: $deepness; Num_stack: $num_stack; Value: $1" >&2      

      eval "number${num_stack}=$1"            
      
      if expr2 $num_stack ">" 2; then
      
        echo "Error: Stack overflow";
        exit 1;
      
      elif expr2 $num_stack "=" 2; then      
        return 0;      
      else       
        return 1                    
      fi       
    }
    
    op_stack_in() {  # operation stack
    
      op_stack=$(( $op_stack + 1 ));
      eval "op${op_stack}=\"$1\""      
                
    }

    op_stack_out() {
    
      eval "op=\$op${op_stack};"
      op_stack=$(( $op_stack - 1 ));
    }

    do_op() {
    
      op_stack_out;
      
      case "$op" in        
        "="|">"|"<"|"!=") num_stack=0;
                          num_stack_in $(expr $number1 "$op" $number2);;        
 
                    "-a") num_stack=0;
                          echo $number1 $number2 >&2; 
                          if expr2 $number1 "=" 1 && expr2 $number2 "=" 1; then
                            num_stack_in 1;
                          else
                            num_stack_in 0;
                          fi;;            
                    "-o") num_stack=0;
                          
                          if expr2 $number1 "=" 1 || expr2 $number2 "=" 1; then
                            num_stack_in 1;
                          else
                            num_stack_in 0;
                          fi;;            
                       *) echo "Unknown operation: "'`'"$op\""; exit 1;;
      esac
    
    }

    
    while expr2 $# ">" "0"; do
    
      switch="$1"
      echo 'Deepness: '"$deepness"'; Switch: `'"$switch\"" >&2
      shift      
      
      case "$switch" in
         
          ')')  #if expr2 $opened_with_bracket "=" 0; then
                #  echo "$number1 "$(($# - 1)); # process ")" again
                #else
                  echo "$number1 $#";
                #fi   
                return 0;;
         
          '(')  partial_result=$(process 0 $(( $deepness + 1 )) "$@");
                switch=$(echo "$partial_result" | cut -d" " -f 1);
                remaining_switches=$(echo "$partial_result" | cut -d" " -f 2);                
                shift $(($# - $remaining_switches));; # shift after ")"
         
          # test if $1 is empty
          "-z") if expr2 "dd${1}dd" "=" "dddd"; then
                  switch=1;
                else
                  switch=0;
                fi
                shift;;

          "-n") if expr2 "dd${1}dd" "=" "dddd"; then
                  switch=0;
                else
                  switch=1;
                fi
                shift;;                                  
      esac
      
      case "$switch" in      
                 "-a"|"-o") if expr2 $opened_with_logical_switch "=" 1; then
                              # $# + 1 because we want to process -a or -o again. 
                              # (in this function the switch -a / -o are shifted)
                              echo "$number1 "$(($# + 1)); 
                              return 0; 
                            fi                                              

                            op_stack_in "$switch";

                            partial_result=$(process 1 $(( $deepness + 1 )) "$@");
                            
                            if echo "$partial_result" | grep -q '^[10]\{1\}$'; then
                              switch=$partial_result;
                              remaining_switches=0;
                            else                            
                              switch=$(echo "$partial_result" | cut -d" " -f 1);
                              remaining_switches=$(echo "$partial_result" | cut -d" " -f 2);
                            fi
                            
                            if num_stack_in $switch; then
                              do_op # with "$number1" "$number2"
                            fi
                            shift $(( $# - $remaining_switches ));;                            
                    [0-9]*) if num_stack_in "$switch"; then
                              do_op # with "$number1" "$number2"
                            fi;;
                       "=") op_stack_in "=";;
                      "!=") op_stack_in "!=";;
                       ')') op_stack_in ')';;
                       '(') op_stack_in '(';;
                     '-gt') op_stack_in '>';;
                     '-lt') op_stack_in '<';;
                         *) echo 'Switch `'"$switch\" - not known"; exit 2;;
      esac      
    
    done;    
    
    if expr2 $num_stack "=" 1 && expr2 $number1 "=" "1"; then      
      echo 1        
      return 0;
    else
      echo 0
      return 1;
    fi    
  
  }
  
  
  # MAIN SCRIPT STARTS HERE
  # ========================= 
  
  if expr2 "$#" "=" "0"; then  
    usage;    
  else               
    
    process 0 "1" "$@"               # verbose version
    # process "1" "$@" >/dev/null    # silent version
    exit $?   
  fi

THERE MAY BE A LOT OF BUGS ---> IT'S 2AM; AND THERE'RE A LOT Of FEATURES TO ADD...

Enjoy :-)
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Want to get the exit status

Hi All, I am trying to create a zip file with all the txt files(these are in large number) in the current directory. I am able to do this operation sucessfully. After this i want to get the status of the tar command executed and do accordingly. When i am trying with the below code, the status... (3 Replies)
Discussion started by: paddu
3 Replies

2. Shell Programming and Scripting

Exit Status

I have a shell script (#!/bin/sh) that interacts with Appworx and Banner Admin. In my script I want to check the exit status of awrun before continuing. awrun can run for 10 seconds or it can run for over a minute. So my question is, will it go through my if statement before awrun may even be... (2 Replies)
Discussion started by: smkremer
2 Replies

3. UNIX for Dummies Questions & Answers

service exit status

what are the number for the exit status for command service and what does every number mean. (2 Replies)
Discussion started by: programAngel
2 Replies

4. Shell Programming and Scripting

Exit status of grep

I am trying to get the exit status of grep and test a condition with it, But it does not seem to be working as expected since i am doing something wrong apparently as per grep help Exit status is 0 if match, 1 if no match, and 2 if trouble. My problem is something like this templine - a... (7 Replies)
Discussion started by: prasbala
7 Replies

5. Shell Programming and Scripting

Check for exit status

Hi I have following code I want If whole code executes successfully then return true If found any error then print the error I tried if ; then But this checks only for the just upper line execution #!/bin/bash PATH1=/var/log/mysql PATH2=/home/ankur/log FILE1=mysql-bin.index... (4 Replies)
Discussion started by: kaushik02018
4 Replies

6. Shell Programming and Scripting

How to get the exit status

Hi all, I'm running a program which return 1 upon success. But when encounters problem shell return 's '1' . How to differentiate between them the shell return value and script return value. Ex. function fn return '1' if executed successfully and '0' if failed. But when if shell encounters... (1 Reply)
Discussion started by: yhacks
1 Replies

7. Shell Programming and Scripting

Checking Exit Status

I hope one of you smart people out there can help me with what seems like a real simple questing but I can't quite figure out. In a script I am doing a cmp on two files. I am trying to check the exit status with an if statement but can't seem to figure out the syntax. If the exit status is 1 I... (4 Replies)
Discussion started by: PrimeRibAndADew
4 Replies

8. Shell Programming and Scripting

Problem with exit status

Hi, Consider the output of the following commands: case1) ------- # ifconfig -a | grep "UP" | grep uplink0:1 # echo $? Output is: 0 case2 ------ # ifconfig -a | grep "UP" | grep uplink0:1; echo $? Output is: 1 In case2 we got the exit code as 1, which is the actual exit code.... (1 Reply)
Discussion started by: diganta
1 Replies

9. Shell Programming and Scripting

exit status

i downloaded a text file from metalab.unc.edu called sh.txt and in this reference manual it refers to shell scripting exit status .. at the end of one of the examples that author gave an exit status of 127.. to what does a 127 exit status refer too and what is its purpose in the code. moxxx68 (1 Reply)
Discussion started by: moxxx68
1 Replies

10. UNIX for Dummies Questions & Answers

tar exit status

I am using tar to backup files to tape. When the tape is full, I'm prompted for a second tape and told to press enter when ready. When I press enter, tar stops and gives an exit status of 5. Does anyone know what this indicates? Also, if everything fits on one tape and the backup... (3 Replies)
Discussion started by: thorndike
3 Replies
Login or Register to Ask a Question